org.mariadb.jdbc

## Class MySQLClientPreparedStatement

- java.lang.Object
- - org.mariadb.jdbc.MySQLStatement
  - - org.mariadb.jdbc.AbstractMySQLPrepareStatement
    - - org.mariadb.jdbc.MySQLClientPreparedStatement

All Implemented Interfaces:
  AutoCloseable, PreparedStatement, Statement, Wrapper

    public class MySQLClientPreparedStatement
    extends AbstractMySQLPrepareStatement

### Field Summary

### Fields inherited from class org.mariadb.jdbc.MySQLStatement

`batchResultSet, connection, firstRewrite, isRewriteable, protocol, queryResult, stLock, timerTask`

### Fields inherited from interface java.sql.Statement

`CLOSE_ALL_RESULTS, CLOSE_CURRENT_RESULT, EXECUTE_FAILED, KEEP_CURRENT_RESULT, NO_GENERATED_KEYS, RETURN_GENERATED_KEYS, SUCCESS_NO_INFO`

### Constructor Summary

Constructors
Constructor and Description
`MySQLClientPreparedStatement(MySQLConnection connection, String sql)`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `addBatch()` Adds a set of parameters to this `PreparedStatement` object's batch of commands.
`void` `addBatch(String sql)` Adds the given SQL command to the current list of commmands for this `Statement` object.
`protected Calendar` `cal()`
`void` `clearBatch()` Empties this `Statement` object's current list of SQL commands.
`void` `clearParameters()` Clears the current parameter values immediately.
`void` `close()` Releases this `Statement` object's database and JDBC resources immediately instead of waiting for this to happen when it is automatically closed.
`boolean` `execute()` Executes the SQL statement in this `PreparedStatement` object, which may be any kind of SQL statement.
`ResultSet` `executeQuery()` Executes the SQL query in this `PreparedStatement` object and returns the `ResultSet` object generated by the query.
`int` `executeUpdate()` Executes the SQL statement in this `PreparedStatement` object, which must be an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement.
`ResultSetMetaData` `getMetaData()` Retrieves a `ResultSetMetaData` object that contains information about the columns of the `ResultSet` object that will be returned when this `PreparedStatement` object is executed.
`ParameterMetaData` `getParameterMetaData()` Retrieves the number, types and properties of this `PreparedStatement` object's parameters.
`protected boolean` `isNoBackslashEscapes()`
`protected void` `setParameter(int parameterIndex, ParameterHolder holder)`
`String` `toString()`
`protected boolean` `useFractionalSeconds()`

### Methods inherited from class org.mariadb.jdbc.AbstractMySQLPrepareStatement

`setArray, setAsciiStream, setAsciiStream, setAsciiStream, setBigDecimal, setBinaryStream, setBinaryStream, setBinaryStream, setBlob, setBlob, setBlob, setBoolean, setByte, setBytes, setCharacterStream, setCharacterStream, setCharacterStream, setClob, setClob, setClob, setDate, setDate, setDouble, setFloat, setInt, setLong, setNCharacterStream, setNCharacterStream, setNClob, setNClob, setNClob, setNString, setNull, setNull, setNull, setObject, setObject, setObject, setRef, setRowId, setShort, setSQLXML, setString, setTime, setTime, setTimestamp, setTimestamp, setUnicodeStream, setURL`

### Methods inherited from class org.mariadb.jdbc.MySQLStatement

`cacheMoreResults, cancel, clearWarnings, closeOnCompletion, execute, execute, execute, execute, execute, execute, executeBatch, executeQuery, executeQuery, executeUpdate, executeUpdate, executeUpdate, executeUpdate, executeUpdate, getConnection, getFetchDirection, getFetchSize, getGeneratedKeys, getInsertIncipit, getMaxFieldSize, getMaxRows, getMoreResults, getMoreResults, getMoreResults, getProtocol, getQueryTimeout, getResultSet, getResultSetConcurrency, getResultSetHoldability, getResultSetType, getUpdateCount, getUpdateCounts, getUpdateCountsForReWrittenBatch, getWarnings, isClosed, isCloseOnCompletion, isInsertRewriteable, isPoolable, isStreaming, isWrapperFor, setCursorName, setEscapeProcessing, setFetchDirection, setFetchSize, setLocalInfileInputStream, setMaxFieldSize, setMaxRows, setPoolable, setQueryTimeout, unloadDriver, unwrap`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.sql.PreparedStatement

`executeLargeUpdate, setObject, setObject`

### Methods inherited from interface java.sql.Statement

`cancel, clearWarnings, closeOnCompletion, execute, execute, execute, execute, executeBatch, executeLargeBatch, executeLargeUpdate, executeLargeUpdate, executeLargeUpdate, executeLargeUpdate, executeQuery, executeUpdate, executeUpdate, executeUpdate, executeUpdate, getConnection, getFetchDirection, getFetchSize, getGeneratedKeys, getLargeMaxRows, getLargeUpdateCount, getMaxFieldSize, getMaxRows, getMoreResults, getMoreResults, getQueryTimeout, getResultSet, getResultSetConcurrency, getResultSetHoldability, getResultSetType, getUpdateCount, getWarnings, isClosed, isCloseOnCompletion, isPoolable, setCursorName, setEscapeProcessing, setFetchDirection, setFetchSize, setLargeMaxRows, setMaxFieldSize, setMaxRows, setPoolable, setQueryTimeout`

### Methods inherited from interface java.sql.Wrapper

`isWrapperFor, unwrap`

### Constructor Detail

#### MySQLClientPreparedStatement

    public MySQLClientPreparedStatement(MySQLConnection connection,
                                        String sql)
                                 throws SQLException

Throws:
  `SQLException`

### Method Detail

#### isNoBackslashEscapes

    protected boolean isNoBackslashEscapes()

Specified by:
  `isNoBackslashEscapes` in class `AbstractMySQLPrepareStatement`

#### useFractionalSeconds

    protected boolean useFractionalSeconds()

Specified by:
  `useFractionalSeconds` in class `AbstractMySQLPrepareStatement`

#### cal

    protected Calendar cal()

Specified by:
  `cal` in class `AbstractMySQLPrepareStatement`

#### executeQuery

    public ResultSet executeQuery()
                           throws SQLException

Executes the SQL query in this `PreparedStatement` object and returns the `ResultSet` object generated by the query.

Returns:
  a `ResultSet` object that contains the data produced by the query; never `null`
Throws:
  `SQLException` - if a database access error occurs; this method is called on a closed `PreparedStatement` or the SQL statement does not return a `ResultSet` object

#### execute

    public boolean execute()
                    throws SQLException

Executes the SQL statement in this `PreparedStatement` object, which may be any kind of SQL statement. Some prepared statements return multiple results; the `execute` method handles these complex statements as well as the simpler form of statements handled by the methods `executeQuery` and `executeUpdate`.
The `execute` method returns a `boolean` to indicate the form of the first result. You must call either the method `getResultSet` or `getUpdateCount` to retrieve the result; you must call `getMoreResults` to move to any subsequent result(s).

Returns:
  `true` if the first result is a `ResultSet` object; `false` if the first result is an update count or there is no result
Throws:
  `SQLException` - if a database access error occurs; this method is called on a closed `PreparedStatement` or an argument is supplied to this method
See Also:
  `Statement.execute(java.lang.String)`, `Statement.getResultSet()`, `Statement.getUpdateCount()`, `Statement.getMoreResults()`

#### executeUpdate

    public int executeUpdate()
                      throws SQLException

Executes the SQL statement in this `PreparedStatement` object, which must be an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement.

Returns:
  either (1) the row count for SQL Data Manipulation Language (DML) statements or (2) 0 for SQL statements that return nothing
Throws:
  `SQLException` - if a database access error occurs; this method is called on a closed `PreparedStatement` or the SQL statement returns a `ResultSet` object

#### addBatch

    public void addBatch()
                  throws SQLException

Adds a set of parameters to this `PreparedStatement` object's batch of commands.

Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `PreparedStatement`
Since:
  1.2
See Also:
  `Statement.addBatch(java.lang.String)`

#### addBatch

    public void addBatch(String sql)
                  throws SQLException

Description copied from class: `MySQLStatement`
Adds the given SQL command to the current list of commmands for this `Statement` object. The commands in this list can be executed as a batch by calling the method `executeBatch`.

Specified by:
  `addBatch` in interface `Statement`
Overrides:
  `addBatch` in class `MySQLStatement`
Parameters:
  `sql` - typically this is a SQL `INSERT` or `UPDATE` statement
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the driver does not support batch updates
See Also:
  `MySQLStatement.executeBatch()`, `DatabaseMetaData.supportsBatchUpdates()`

#### clearBatch

    public void clearBatch()

Description copied from class: `MySQLStatement`
Empties this `Statement` object's current list of SQL commands.

Specified by:
  `clearBatch` in interface `Statement`
Overrides:
  `clearBatch` in class `MySQLStatement`
See Also:
  `MySQLStatement.addBatch(java.lang.String)`, `DatabaseMetaData.supportsBatchUpdates()`

#### getMetaData

    public ResultSetMetaData getMetaData()
                                  throws SQLException

Retrieves a `ResultSetMetaData` object that contains information about the columns of the `ResultSet` object that will be returned when this `PreparedStatement` object is executed.
Because a `PreparedStatement` object is precompiled, it is possible to know about the `ResultSet` object that it will return without having to execute it. Consequently, it is possible to invoke the method `getMetaData` on a `PreparedStatement` object rather than waiting to execute it and then invoking the `ResultSet.getMetaData` method on the `ResultSet` object that is returned.
NOTE: Using this method may be expensive for some drivers due to the lack of underlying DBMS support.

Returns:
  the description of a `ResultSet` object's columns or `null` if the driver cannot return a `ResultSetMetaData` object
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

#### setParameter

    protected void setParameter(int parameterIndex,
                                ParameterHolder holder)
                         throws SQLException

Specified by:
  `setParameter` in class `AbstractMySQLPrepareStatement`
Throws:
  `SQLException`

#### getParameterMetaData

    public ParameterMetaData getParameterMetaData()
                                           throws SQLException

Retrieves the number, types and properties of this `PreparedStatement` object's parameters.

Specified by:
  `getParameterMetaData` in interface `PreparedStatement`
Specified by:
  `getParameterMetaData` in class `AbstractMySQLPrepareStatement`
Returns:
  a `ParameterMetaData` object that contains information about the number, types and properties for each parameter marker of this `PreparedStatement` object
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `PreparedStatement`
Since:
  1.4
See Also:
  `ParameterMetaData`

#### clearParameters

    public void clearParameters()

Clears the current parameter values immediately.

In general, parameter values remain in force for repeated use of a statement. Setting a parameter value automatically clears its previous value. However, in some cases it is useful to immediately release the resources used by the current parameter values; this can be done by calling the method `clearParameters`.

#### close

    public void close()
               throws SQLException

Description copied from class: `MySQLStatement`
Releases this `Statement` object's database and JDBC resources immediately instead of waiting for this to happen when it is automatically closed. It is generally good practice to release resources as soon as you are finished with them to avoid tying up database resources. Calling the method `close` on a `Statement` object that is already closed has no effect. Note:When a `Statement` object is closed, its current `ResultSet` object, if one exists, is also closed.

Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in interface `Statement`
Overrides:
  `close` in class `MySQLStatement`
Throws:
  `SQLException` - if a database access error occurs

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`